diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 76606faa3e..ea9c195934 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -920,7 +920,7 @@ use_physical_tlist(PlannerInfo *root, Path *path, int flags)
 	 * We can only return that without a projection if all the index's columns
 	 * are returnable.
 	 */
-	if (path->pathtype == T_IndexOnlyScan)
+	if (path->pathtype == T_IndexOnlyScan || path->pathtype == T_IndexScan)
 	{
 		IndexOptInfo *indexinfo = ((IndexPath *) path)->indexinfo;
 
